#ifndef PHOEBE_ALLOCATIONS_H
	#define PHOEBE_ALLOCATIONS_H

#include "phoebe_global.h"

int initialize_memory_for_data (PHOEBE_data *data);
int allocate_memory_for_data (PHOEBE_data *data, int records_no);
int free_allocated_memory_for_data (PHOEBE_data *data);

int initialize_memory_for_graph_data (PHOEBE_graph_data *data);
int allocate_memory_for_graph_data (PHOEBE_graph_data *data, int records_no);
int free_allocated_memory_for_graph_data (PHOEBE_graph_data *data);

int read_in_synthetic_data (PHOEBE_data *data, int curve, int indep, int dep, int weight, double phstrt, double phend, int vertices);
int read_in_experimental_data (char *filename, PHOEBE_data *data, int indep, int outindep, int dep, int outdep, int weight, int outweight);
int read_in_wd_lci_parameters (WD_LCI_parameters *params, int MPAGE, int JDPHS, int curve);
int read_in_ephemeris_parameters (double *hjd0, double *period, double *dpdt, double *pshift);
int read_in_graph_data (PHOEBE_graph_data *cache, PHOEBE_data data);

#endif
