#ifndef PHOEBE_GUI_ACCESSORIES_H
	#define PHOEBE_GUI_ACCESSORIES_H 1

#include <gtk/gtk.h>
#include "phoebe_global.h"

/* Functions for reliable working with strings:                               */

int declare_string (char **in, char *contents);
void strip_string_tail (char *in);
void parse_filter_names ();
char *parse_data_line (char *in);

/* Functions for testing filename permissions and attributes:                 */

int filename_exists (char *filename);
int filename_has_write_permissions (char *filename);
int filename_has_read_permissions (char *filename);
int filename_has_execute_permissions (char *filename);
int filename_has_full_permissions (char *filename);
int filename_is_directory (char *filename);
int filename_is_regular_file (char *filename);

/* Other GUI accessories:                                                     */

int print_to_status_bar (const char *fmt, ...);
void parse_startup_line (int argc, char *argv[]);
int  variables_init ();
int  phoebe_init ();
void create_and_set_special_labels ();
void create_all_logging_service_tags ();
void create_internal_plotter_canvas ();
void put_file_contents_to_text_view (char *filename);
void update_lc_statistics_info_list (int row);

void create_all_info_lists ();

void create_data_lc_info_list ();
void create_data_rv_info_list ();
void create_data_sp_info_list ();
void create_flux_levelers_info_list ();
void create_third_light_info_list ();
void create_ld_mono_lc_info_list ();
void create_ld_mono_rv_info_list ();
void create_spots_primary_info_list ();
void create_spots_secondary_info_list ();
void create_plot_lc_data_info_list ();
void create_plot_lc_statistics_info_list ();
void create_lc_statistics_info_list ();
void create_rv_statistics_info_list ();
void create_scripter_info_list ();

void add_empty_record_to_all_lc_dependent_info_lists ();
void add_empty_record_to_all_rv_dependent_info_lists ();
void add_empty_record_to_all_sp_dependent_info_lists ();

void add_empty_record_to_lc_info_list ();
void add_empty_record_to_rv_info_list ();
void add_empty_record_to_sp_info_list ();
void add_empty_record_to_flux_levelers_info_list ();
void add_empty_record_to_third_light_info_list ();
void add_empty_record_to_ld_mono_lc_light_info_list ();
void add_empty_record_to_ld_mono_rv_light_info_list ();
void add_empty_record_to_plot_lc_info_list ();
void add_empty_record_to_lc_statistics_info_list ();
void add_empty_record_to_rv_statistics_info_list ();
void add_empty_record_to_plot_lc_statistics_info_list ();

/* Functions not in GTK but should be ;)   :                                  */

gint gtk_tree_view_column_get_index (GtkTreeViewColumn *column);
void editable_cell_with_double_edited (GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer data);
void editable_cell_with_string_edited (GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer data);

#endif
