#include <gtk/gtk.h>

void on_switches_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_inverted_switches_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void on_parameter_value_changed_update_ties (GtkSpinButton *spinbutton, gpointer user_data);

void on_data_lc_no_value_changed (GtkSpinButton *spinbutton, gpointer user_data);
void on_data_rv_no_value_changed (GtkSpinButton *spinbutton, gpointer user_data);
void on_data_sp_no_value_changed (GtkSpinButton *spinbutton, gpointer user_data);
void on_data_synthetic_scatter_seed_button_clicked (GtkButton *button, gpointer user_data);

int  on_configuration_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_configuration_save_button_clicked (GtkButton *button, gpointer user_data);
void on_configuration_cancel_button_clicked (GtkButton *button, gpointer user_data);
void on_configuration_browse_button_clicked (GtkButton *button, gpointer user_data);
void on_configuration_file_selector_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_configuration_file_selector_cancel_button_clicked (GtkButton *button, gpointer user_data);

/* *********************   Warning windows' callbacks   ********************* */

void on_warning_window_configuration_missing_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_warning_window_configuration_file_exists_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_warning_window_log_file_exists_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_warning_window_overwrite_keyword_file_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_warning_window_save_keyword_file_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_warning_window_restore_defaults_ok_button_clicked (GtkButton *button, gpointer user_data);

/* *************************   Menu bar callbacks  ************************** */

void on_menu_bar_file_new_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_open_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_save_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_save_as_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_import_from_dci_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_export_to_dci_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_file_quit_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_edit_log_window_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_view_plot_light_curves_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_view_plot_rv_curves_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_view_data_sheet_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_actions_initiate_scripter_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_settings_configuration_selected (GtkMenuItem *menuitem, gpointer user_data);
void on_menu_bar_help_about_selected (GtkMenuItem *menuitem, gpointer user_data);

/* ***************   Surface potential calculation callbacks   ************** */

void on_component_phsv_calculate_button_clicked (GtkButton *button, gpointer user_data);
void on_component_pcsv_calculate_button_clicked (GtkButton *button, gpointer user_data);
void on_calculate_surface_potentials_calculate_button_clicked (GtkButton *button, gpointer user_data);
void on_calculate_surface_potentials_update_button_clicked (GtkButton *button, gpointer user_data);
void on_calculate_surface_potentials_critical_value_changed (GtkEditable *editable, gpointer user_data);
void on_calculate_surface_potentials_potential_value_changed (GtkEditable *editable, gpointer user_data);

/* ********************   Keywords related callbacks   ********************** */

void on_keywords_file_selector_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_keywords_file_selector_cancel_button_clicked (GtkButton *button, gpointer user_data);

/* ****************   Experimental data related callbacks   ***************** */

gboolean on_data_lc_info_double_clicked (GtkWidget *widget, GdkEvent *event, gpointer user_data);
gboolean on_data_rv_info_double_clicked (GtkWidget *widget, GdkEvent *event, gpointer user_data);
gboolean on_data_sp_info_double_clicked (GtkWidget *widget, GdkEvent *event, gpointer user_data);

void on_assign_lc_data_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_assign_lc_data_cancel_button_clicked (GtkButton *button, gpointer user_data);
void on_assign_rv_data_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_assign_rv_data_cancel_button_clicked (GtkButton *button, gpointer user_data);
void on_assign_sp_data_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_assign_sp_data_cancel_button_clicked (GtkButton *button, gpointer user_data);

void on_data_filename_browse_button_clicked (GtkButton *button, gpointer user_data);
void on_data_file_selector_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_data_file_selector_cancel_button_clicked (GtkButton *button, gpointer user_data);

void on_filter_menu_specific_filter_activate (GtkMenuItem *menuitem, gpointer user_data);
void on_assign_lc_data_filter_button_clicked (GtkButton *button, gpointer user_data);

void on_plot_lc_plot_button_clicked (GtkButton *button, gpointer user_data);
void on_plot_lc_plot_to_button_clicked (GtkButton *button, gpointer user_data);
void on_plot_lc_clear_button_clicked (GtkButton *button, gpointer user_data);
void on_plot_lc_close_button_clicked (GtkButton *button, gpointer user_data);

void on_data_lc_info_list_row_changed (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer user_data);
void on_data_rv_info_list_row_changed (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer user_data);

void on_data_statistics_button_clicked (GtkButton *button, gpointer user_data);
void on_statistics_close_button_clicked (GtkButton *button, gpointer user_data);

gboolean on_plot_lc_data_info_list_clicked (GtkWidget *treeview, GdkEventButton *event, gpointer userdata);

/* ****************   Callbacks connected to Utilities tab   **************** */

void on_system_ephemeris_changed (GtkSpinButton *spinbutton, gpointer user_data);
void on_utilities_phase_calculator_hjd_value_changed (GtkSpinButton *spinbutton, gpointer user_data);
void on_utilities_main_sequence_calculator_update_button_clicked (GtkButton *button, gpointer user_data);
void on_utilities_main_sequence_calculator_calculate_button_clicked (GtkButton *button, gpointer user_data);

/* ****************   Callbacks connected to Log Services   ***************** */

void on_logging_write_to_file_button_clicked (GtkButton *button, gpointer user_data);
void on_logging_service_file_selector_ok_button_clicked (GtkButton *button, gpointer user_data);
void on_logging_service_file_selector_cancel_button_clicked (GtkButton *button, gpointer user_data);

/* ***********************   Scripting callbacks   ************************** */

void on_scripter_open_script_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_save_script_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_execute_script_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_close_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_add_action_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_update_action_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_delete_action_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_move_action_up_button_clicked (GtkButton *button, gpointer user_data);
void on_scripter_move_action_down_button_clicked (GtkButton *button, gpointer user_data);

void on_scripter_action_changed (GtkOptionMenu *optionmenu, gpointer user_data);
