#include <gtk/gtk.h>

#include "phoebe_error_handling.h"
#include "phoebe_keywords.h"

int handle_open_keyword_file_exceptions (int code)
	{
	/* This function handles all predicted open_keyword_file exceptions:        */
	/*                                                                          */
	/*   code = 0 : everything OK                                               */
	/*   code = 1 : trying to open a legacy (pre-0.20) keyword file             */

	GtkWidget *notice_window;

	if (code == 0) return;
	if (code == 1)
		{
		notice_window = create_notice_window (
			"Notice",
			"Opening legacy PHOEBE keyword file format",
		  "PHOEBE keywords have changed in version 0.2. Although your file has been",
			"opened, please convert it to the current format simply by saving it.",
			G_CALLBACK (gtk_widget_destroy));
		}
	}
