#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>

#include "phoebe_global.h"
#include "phoebe_gui_accessories.h"
#include "phoebe_gui_support.h"

void create_logging_service_tags (GtkTextBuffer *buffer)
	{
	/* This function creates a bunch of tags that are used in the logging ser-  */
	/* vice window.                                                             */

  GdkBitmap *stipple;

  gtk_text_buffer_create_tag (buffer, "heading",        "weight",             PANGO_WEIGHT_BOLD,
                                                        "size",               15 * PANGO_SCALE,			  NULL);
  gtk_text_buffer_create_tag (buffer, "monospace",      "family",             "monospace", NULL);

  gtk_text_buffer_create_tag (buffer, "normal",         "style",              PANGO_STYLE_NORMAL,     NULL);
  gtk_text_buffer_create_tag (buffer, "italic",         "style",              PANGO_STYLE_ITALIC,     NULL);
  gtk_text_buffer_create_tag (buffer, "bold",           "weight",             PANGO_WEIGHT_BOLD,      NULL);
  gtk_text_buffer_create_tag (buffer, "underline",      "underline",          PANGO_UNDERLINE_SINGLE, NULL);
  gtk_text_buffer_create_tag (buffer, "strikethrough",  "strikethrough",      TRUE,                   NULL);

  gtk_text_buffer_create_tag (buffer, "xx-small",       "scale",              PANGO_SCALE_XX_SMALL,   NULL);
  gtk_text_buffer_create_tag (buffer, "big",            "size",               20 * PANGO_SCALE,       NULL);
  gtk_text_buffer_create_tag (buffer, "x-large",        "scale",              PANGO_SCALE_X_LARGE,    NULL);

  gtk_text_buffer_create_tag (buffer, "double_spacing", "pixels_inside_wrap", 10,                     NULL);

  gtk_text_buffer_create_tag (buffer, "not_editable",   "editable",           FALSE,                  NULL);

  gtk_text_buffer_create_tag (buffer, "word_wrap",      "wrap_mode",          GTK_WRAP_WORD,          NULL);
  gtk_text_buffer_create_tag (buffer, "char_wrap",      "wrap_mode",          GTK_WRAP_CHAR,          NULL);
  gtk_text_buffer_create_tag (buffer, "no_wrap",        "wrap_mode",          GTK_WRAP_NONE,          NULL);

  gtk_text_buffer_create_tag (buffer, "left-justify",   "justification",      GTK_JUSTIFY_LEFT,       NULL);
  gtk_text_buffer_create_tag (buffer, "center",         "justification",      GTK_JUSTIFY_CENTER,     NULL);
  gtk_text_buffer_create_tag (buffer, "right_justify",  "justification",      GTK_JUSTIFY_RIGHT,      NULL);
  
  gtk_text_buffer_create_tag (buffer, "superscript",    "rise",               10 * PANGO_SCALE,
                                                        "size",                8 * PANGO_SCALE,			  NULL);
  gtk_text_buffer_create_tag (buffer, "subscript",      "rise",              -10 * PANGO_SCALE,
                                                        "size",                8 * PANGO_SCALE,	      NULL);
	}

int write_log_to_file (char *filename)
	{
	/* This function writes the log to file specified by *filename. This string */
	/* has to be valid, it is up to the calling function to make sure of that.  */

	GtkTextIter start, end;
	GtkTextBuffer *buffer;

	FILE *file;

	file = fopen (filename, "w");

	fprintf (file, "GENERAL INFORMATION:\n");
	fprintf (file, "--------------------\n\n");

	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (lookup_widget (PHOEBE_logging_service, "logging_general_information_entry")));
  gtk_text_buffer_get_iter_at_offset (buffer, &start, 0);
  gtk_text_buffer_get_iter_at_offset (buffer, &end,   0);
	gtk_text_iter_forward_to_end (&end);
	fprintf (file, "%s\n", gtk_text_buffer_get_text (buffer, &start, &end, FALSE));

	fprintf (file, "\nOBSERVATIONAL FACTS:\n");
	fprintf (file, "--------------------\n\n");

	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (lookup_widget (PHOEBE_logging_service, "logging_observational_facts_entry")));
  gtk_text_buffer_get_iter_at_offset (buffer, &start, 0);
  gtk_text_buffer_get_iter_at_offset (buffer, &end,   0);
	gtk_text_iter_forward_to_end (&end);
	fprintf (file, "%s\n", gtk_text_buffer_get_text (buffer, &start, &end, FALSE));

	fprintf (file, "\nANALYSIS LOG:\n");
	fprintf (file, "-------------\n\n");

	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (lookup_widget (PHOEBE_logging_service, "logging_analysis_log_entry")));
  gtk_text_buffer_get_iter_at_offset (buffer, &start, 0);
  gtk_text_buffer_get_iter_at_offset (buffer, &end,   0);
	gtk_text_iter_forward_to_end (&end);
	fprintf (file, "%s\n", gtk_text_buffer_get_text (buffer, &start, &end, FALSE));

	fclose (file);

	return 0;
	}
